import os
import csv
import pytest

from osgeo import gdal


@pytest.fixture
def products():
    with open('./preprocessed_list.csv') as f:
        yield csv.reader(f)


def test_preprocessor(products):
    products_list = []
    container = '../data/preprocessor_results'
    result_list = os.listdir(container)
    for product in products:
        products_list.append(product[0])

    # check if there are preprocessed results in the buckets
    assert len(result_list) > 0
    result_list.sort()
    products_list.sort()
    assert result_list == products_list

    preprocessed_list = []
    for item in products_list:
        files = os.listdir('%s/%s' % (container, item))
        for data in files:
            if data.endswith("tif"):
                preprocessed_list.append('%s/%s/%s' % (container, item, data))
    for item in preprocessed_list:
        image = gdal.Open(item, gdal.GA_ReadOnly)
        srcband = image.GetRasterBand(1)
        assert srcband.Checksum() is not None
        assert srcband.Checksum() > 0
